"""PHP-style authorisation functions.

Version:

    File Version 0.1 for LEMON 0.2
    
Usage:

    session = lemon.session.SessionDB(self.database, appName)  # Retrieve the session or create a new one
    auth    = lemon.auth.AuthDB(session)                # Create auth object from the session information
    
    if auth.isValid():                                  # See if the User is logged on else present login form.
        user = a.getUser()                              # Return a user object containing user's details.
        user.Password                                   # Access the data via attributes or dict style.
        user.getStatus()                                # Retrieve the entry for the appName column.

ToDO:

    addUser, RemoveUser etc.
    gadfly
    create the database if not already there?? 
    definately need config file similar to php.ini
"""



__author__ = "James Gardner [email: james at xecos.com]"
__date__ = "02 July 2003"
__version__ = "Version 0.1 for LEMON 0.2"[-3:]
__credits__ = "Guido van Rossum, for an excellent programming language."

import time, md5, db
import base

class DB(base.Base):
    "Database interface to the authorisation code."
    
    def __init__(self, conn):
        #self.conn = conn
        #self.database = conn.cursor(autoConvert=True)
        self.database = conn
        
    def getInfo(self, name, username):
        # XXX BUG: shouldn't where include the name.
        "Returns a tuple where the first and only entry is a tuple containg the username, password, and accesslevel for the user named username and the application named name."
        list = [0,1,2,3,4,5]
        rows = self.database.select(('User', 'Password','Firstname','Surname','Email'),'AuthUsers', where="User='"+ username+"'", fetchMode='tuple')
        if rows:
            list[0] = rows[0][0]
            list[1] = rows[0][1]
            list[3] = rows[0][2]
            list[4] = rows[0][3]
            list[5] = rows[0][4]
        else:
            return None
        rows = self.database.select('AccessLevel', 'Auth', where="App='"+name+"' and User='"+ username +"'", fetchMode='tuple')
        if rows:
            list[2] = rows[0][0]
        else:
            list[2] = 0
            
    
        return (tuple(list),)

    def getLoginInfo(self, username):
        return self.database.select(('User','Password'), 'AuthUsers', where="User='"+username+"'")
        #self.database.execute("select User, Password from AuthUsers where User='"+username+"'")
        #return self.database.fetchall()
        
    def getEmail(self, username):
        rows = self.database.select(('User', 'Password','Firstname','Surname','Email'),'AuthUsers', where="User='"+ username+"'", fetchMode='tuple')
        if rows:
            return rows[0][4]
        else:
            return None

    def getPassword(self, username):
        rows = self.database.select(('User', 'Password','Firstname','Surname','Email'),'AuthUsers', where="User='"+ username+"'", fetchMode='tuple')
        if rows:
            return rows[0][1]
        else:
            return None
            
    def getFirstname(self, username):
        rows = self.database.select(('User', 'Password','Firstname','Surname','Email'),'AuthUsers', where="User='"+ username+"'", fetchMode='tuple')
        if rows:
            return rows[0][2]
        else:
            return None