

database = None

##### Create, Drop, Auto Increment.

def newID(table):
    m = max(table,'rowid')
    if not m:
        return 1
    return int(m) + 1
    #print max #XXX MAJOR BUG. Comes back as Long.
        
        
def colUnique(table, name, value, type): # is type needed.
    if type in ['INTEGER', 'FLOAT']: 
        rows = database.SELECT(name,table,WHERE = name + "=" + str(value))
    else:
        rows = database.SELECT(name,table,WHERE = name + "='" + str(value) + "'")
    if len(rows) > 0:
        return False
    return True
    
def rowids( table, where=None, order=None):
    "Returns a list of row 'rowid's which rows matching the criteria."
    rows = database.select('rowid', table, where=where, orderby=order)
    rowids = []
    for row in rows:
        rowids.append(int(row[0]))
    return rowids
    
#
# SQL Funcitons
#

def max(table, name):
    "Returns the highest value in the column 'name'."
    return database.FUNCTION('MAX', name, table)
    
def min(table, name):
    "Returns the lowest value in the column 'name'."
    return database.FUNCTION('MIN', name, table)
    
def sum(table, name):
    "Returns the sum of the values in the column 'name'."
    return database.FUNCTION('SUM', name, table)
    
def average(table, name):
    "Returns the average value of the column 'name'."
    return database.FUNCTION('AVG', name, table)

def exists(table):
    return database.tableExists(table)
    
def rowExists(table, rowid):
    rows = database.SELECT('rowid', table, WHERE="rowid="+str(rowid))
    if rows:
        return True
    return False
        
def getRow(table, fields, rowid):
    return database.SELECT(fields, table, WHERE="rowid="+str(rowid))
    
def fieldsExist(table, fields, rowid):
    rows = getRow(table, fields, rowid)
    if not (rows and len(rows[0]) == len(fields)):
        return False
    return True
                
def addRow(table, fields, values): # XXX AutoIncrement.
    rowid = newID(table)
    fields.insert(0, 'rowid')
    values.insert(0, rowid)
    return database.INSERT(table, fields, values)
    
def updateRow(table, rowid, fields, values):
    return database.UPDATE(table, fields, values, WHERE='rowid='+str(rowid))
    
def removeRow(table, rowid):
    return database.DELETE(table, WHERE="rowid="+str(rowid))

def removeRows(table, query):
    return database.DELETE(table, WHERE=str(query))
    